# Домашний центр сертификации
Данный пример центра сертификации поможет при проведении опытов с клиентскими и серверными сертификатами

## Структура проекта
```
├──./SSL_Cert_Gen
│   ├── /ca_root - корневой, главный УЦ
│   │   ├── openssl.conf - конфиг корневого УЦ
│   │   ├── index.txt - база данных сертификатов
│   │   ├── serial - счетчик серийных номеров
│   │   ├── /pub - каталог с открытыми ключами
│   │   ├── /priv - каталог с закрытыми ключами
│   │   ├── /newcerts - каталог с подписанными сертификатами
│   │ 
│   ├── /ca1 - промежуточный УЦ
│   │   ├── openssl.conf - конфиг промежуточного УЦ
│   │   ├── index.txt - база данных сертификатов
│   │   ├── serial - счетчик серийных номеров
│   │   ├── /pub - каталог с открытыми ключами
│   │   ├── /priv - каталог с закрытыми ключами
│   │   ├── /newcerts - каталог с подписанными сертификатами
│   │   ├── /csr - каталог с запросами на подпись
│   │   ├── /psk12 - каталог с ключевыми парами
```

## Конфигурация
'ca_root/openssl.conf' - путь


## Создание корневого удостоверяющего сертификата

Переходим в папку корневого сертификата
```
cd ./ca_root
```
```
openssl genrsa -aes256 -out priv/ca.key 4096
```

```
openssl req -config openssl.conf \
-key priv/ca.key \
-new -x509 -days 7300 -sha256 -extensions v3_ca \
-out pub/ca.crt
```
